//
//  ̐
//

#ifndef _GENMOVES_
#define _GENMOVES_

#include "kyokumen.h"
#include "attack.h"


#define KOMA_FU		1
#define KOMA_KY		2
#define KOMA_KE		3
#define KOMA_GI		4
#define KOMA_KI		5
#define KOMA_KA		6
#define KOMA_HI		7
#define KOMA_OU		8
#define KOMA_TO		9
#define KOMA_NY		10
#define KOMA_NK		11
#define KOMA_NG		12
#define KOMA_UM		13
#define KOMA_RY		14

#define DROP_TE(koma, te, pos)		\
te[num].from = -koma;				\
te[num].to   = pos;					\
te[num].nari = 0;					\
num++;								\

#define ADD_TE_W(player, te, pos, to, in)	\
if(in->kifu[to] <= 0)				\
{									\
te[num].from = pos;					\
te[num].to   = to;					\
te[num].koma = in->kifu[pos];		\
te[num].nari = (nari_koma[player][te[num].koma][to] || nari_koma[player][te[num].koma][pos]?1:0);		\
num++;								\
if(in->kifu[to] < 0)				\
	break;							\
} else break;						\

#define ADD_TE_B(player, te, pos, to, in)	\
if(in->kifu[to] >= 0)				\
{									\
te[num].from = pos;					\
te[num].to   = to;					\
te[num].koma = in->kifu[pos];		\
te[num].nari = (nari_koma[player][-te[num].koma][to] || nari_koma[player][-te[num].koma][pos]?1:0);		\
num++;								\
if(in->kifu[to] > 0)				\
	break;							\
} else break;						\

#define HAND_FU	0
#define HAND_KY	1
#define HAND_KE	2
#define HAND_GI	3
#define HAND_KI	4
#define HAND_KA	5
#define HAND_HI	6

// u̐
int gen_drop(int player, struct kyokumen_t * in, struct te_t * te)
{
	int num = 0;
	int pos;
	char nifu[9] = {0};

	if(player == 0)
	{
		// 
		if(in->kifu[81 + HAND_FU])
		{
			// 2hu
			for(pos = 0;pos < 81;pos++)
			{
				if(in->kifu[pos] == 1)
				{
					nifu[pos % 9] = 1;
				}
			};
			for(pos = 9;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0 && nifu[pos % 9] ==0)
				{
					DROP_TE(KOMA_FU, te, pos);
				}
			}
		}
		// 
		if(in->kifu[81 + HAND_KY])
		{
			for(pos = 9;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_KY, te, pos);
				}
			}
		}
		// j
		if(in->kifu[81 + HAND_KE])
		{
			for(pos = 18;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_KE, te, pos);
				}
			}
		}
		// 
		if(in->kifu[81 + HAND_GI])
		{
			for(pos = 0;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_GI, te, pos);
				}
			}
		}
		// 
		if(in->kifu[81 + HAND_KI])
		{
			for(pos = 0;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_KI, te, pos);
				}
			}
		}
		// p
		if(in->kifu[81 + HAND_KA])
		{
			for(pos = 0;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_KA, te, pos);
				}
			}
		}
		// 
		if(in->kifu[81 + HAND_HI])
		{
			for(pos = 0;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_HI, te, pos);
				}
			}
		}
	} else {
		// 
		if(in->kifu[88 + HAND_FU])
		{
			// 2hu
			for(pos = 0;pos < 81;pos++)
			{
				if(in->kifu[pos] == -1)
				{
					nifu[pos % 9] = 1;
				}
			};
			for(pos = 0;pos < 81 - 9;pos++)
			{
				if(in->kifu[pos] == 0 && nifu[pos % 9] ==0)
				{
					DROP_TE(KOMA_FU, te, pos);
				}
			}
		}
		// 
		if(in->kifu[88 + HAND_KY])
		{
			for(pos = 0;pos < 81 - 9;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_KY, te, pos);
				}
			}
		}
		// j
		if(in->kifu[88 + HAND_KE])
		{
			for(pos = 0;pos < 81 - 18;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_KE, te, pos);
				}
			}
		}
		// 
		if(in->kifu[88 + HAND_GI])
		{
			for(pos = 0;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_GI, te, pos);
				}
			}
		}
		// 
		if(in->kifu[88 + HAND_KI])
		{
			for(pos = 0;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_KI, te, pos);
				}
			}
		}
		// p
		if(in->kifu[88 + HAND_KA])
		{
			for(pos = 0;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_KA, te, pos);
				}
			}
		}
		// 
		if(in->kifu[88 + HAND_HI])
		{
			for(pos = 0;pos < 81;pos++)
			{
				if(in->kifu[pos] == 0)
				{
					DROP_TE(KOMA_HI, te, pos);
				}
			}
		}
	}

	return num;
}


//
// pos̈ʒűړ𐶐
//
int add_te(int player, struct kyokumen_t * in, int type, int pos,  struct te_t * te)
{
	int num = 0;
	int i;
	int to;

	if(player == 0)
	{
		for(i = 0;i < attack_koma[player][type][pos].num;i++)
		{
			to = attack_koma[player][type][pos].pos[i];
			// ړ悪̋łȂΈړ\
			if(
				in->kifu[to] <= 0
				)
			{
				te[num].from = pos;
				te[num].to   = to;
				te[num].koma = in->kifu[pos];
				te[num].nari = 0;
				num++;
				// 
				if(nari_koma[player][in->kifu[pos]][pos] != 0 || nari_koma[player][in->kifu[pos]][to] != 0)
				{
					if(nari_koma[player][in->kifu[pos]][to] == 2)
					{
						// Kʒu
						te[num-1].nari = 1;
					} else {
						te[num].from = pos;
						te[num].to   = to;
						te[num].koma = in->kifu[pos];
						te[num].nari = 1;
						num++;
					}
				} 
			}
		};
	} else {
		for(i = 0;i < attack_koma[player][type][pos].num;i++)
		{
			to = attack_koma[player][type][pos].pos[i];
			// ړ悪̋łȂΈړ\
			if(
				in->kifu[to] >= 0
				)
			{
				te[num].from = pos;
				te[num].to   = to;
				te[num].koma = in->kifu[pos];
				te[num].nari = 0;
				num++;
				// 
				if( (nari_koma[player][-in->kifu[pos]][pos] != 0) || (nari_koma[player][-in->kifu[pos]][to] != 0) )
				{
					if(nari_koma[player][-in->kifu[pos]][to] == 2)
					{
						// Kʒu
						te[num-1].nari = 1;
					} else {

						te[num].from = pos;
						te[num].to   = to;
						te[num].koma = in->kifu[pos];
						te[num].nari = 1;
						num++;
					}
				} 
			}
		};
	}

	return num;
};

// posɂ鍁̈ړ𐶐
int add_te_lance(int player, struct kyokumen_t * in, int type, int pos,  struct te_t * te)
{
	int num = 0;
	int to;

	if(player == 0)
	{
		for(to = pos - 9;to >= 0;to -= 9)
		{
			if(in->kifu[to] <= 0)				
			{									
				te[num].from = pos;					
				te[num].to   = to;					
				te[num].koma = in->kifu[pos];		
				te[num].nari = 0;					
				num++;								
				if(nari_koma[player][KOMA_KY][pos] != 0 || nari_koma[player][KOMA_KY][to] != 0) 
				{										   	
					if(nari_koma[player][KOMA_KY][to] == 2)  
						te[num-1].nari = 1;				   
					else {								   
						te[num].from = pos;				   
						te[num].to   = to;				   
						te[num].koma = in->kifu[pos];	   
						te[num].nari = 1;				   
						num++;							   
					}									   
				}										    
				if(in->kifu[to] < 0)				
					break;							
			} else break;						
		}
	} else {
		for(to = pos + 9;to < 81;to += 9)
		{
			if(in->kifu[to] >= 0)				
			{									
				te[num].from = pos;					
				te[num].to   = to;					
				te[num].koma = in->kifu[pos];		
				te[num].nari = 0;	
				num++;								
				if(nari_koma[player][KOMA_KY][pos] != 0 || nari_koma[player][KOMA_KY][to] != 0) 
				{										   	
					if(nari_koma[player][KOMA_KY][to] == 2)  
						te[num-1].nari = 1;				   
					else {								   
						te[num].from = pos;				   
						te[num].to   = to;				   
						te[num].koma = in->kifu[pos];	   
						te[num].nari = 1;				   
						num++;							   
					}									   
				}										    
				if(in->kifu[to] > 0)				
					break;							
			} else break;						
		}
	};

	return num;
};

// posɂ򗴂̈ړ𐶐
int add_te_rook(int player, struct kyokumen_t * in, int type, int pos,  struct te_t * te)
{
	int num = 0;
	int i;
	int to;

	if(player == 0)
	{
		int i;
		// (ԂԂ邩H)
		for(i = 0;i < tt[pos].num;i++)
		{
			to = tt[pos].pos[i];
			ADD_TE_W(player, te, pos, to, in);
		}
		// 
		for(i = 0;i < bb[pos].num;i++)
		{
			to = bb[pos].pos[i];
			ADD_TE_W(player, te, pos, to, in);
		}
		// 
		for(i = 0;i < ll[pos].num;i++)
		{
			to = ll[pos].pos[i];
			ADD_TE_W(player, te, pos, to, in);
		}
		// E
		for(i = 0;i < rr[pos].num;i++)
		{
			to = rr[pos].pos[i];
			ADD_TE_W(player, te, pos, to, in);
		}

	} else {
		// (ԂԂ邩H)
		for(i = 0;i < tt[pos].num;i++)
		{
			to = tt[pos].pos[i];
			ADD_TE_B(player, te, pos, to, in);
		}
		// 
		for(i = 0;i < bb[pos].num;i++)
		{
			to = bb[pos].pos[i];
			ADD_TE_B(player, te, pos, to, in);
		}
		// 
		for(i = 0;i < ll[pos].num;i++)
		{
			to = ll[pos].pos[i];
			ADD_TE_B(player, te, pos, to, in);
		}
		// E
		for(i = 0;i < rr[pos].num;i++)
		{
			to = rr[pos].pos[i];
			ADD_TE_B(player, te, pos, to, in);
		}

	};

	return num;
};

// posɂpn̈ړ𐶐
int add_te_bishop(int player, struct kyokumen_t * in, int type, int pos,  struct te_t * te)
{
	int num = 0;
	int i;
	int to;

	if(player == 0)
	{
		// 
		for(i = 0;i < lt[pos].num;i++)
		{
			to = lt[pos].pos[i];
			ADD_TE_W(player, te, pos, to, in);
		}
		// E
		for(i = 0;i < rt[pos].num;i++)
		{
			to = rt[pos].pos[i];
			ADD_TE_W(player, te, pos, to, in);
		}
		// 
		for(i = 0;i < lb[pos].num;i++)
		{
			to = lb[pos].pos[i];
			ADD_TE_W(player, te, pos, to, in);
		}
		// E
		for(i = 0;i < rb[pos].num;i++)
		{
			to = rb[pos].pos[i];
			ADD_TE_W(player, te, pos, to, in);
		}
	} else {
		// 
		for(i = 0;i < lt[pos].num;i++)
		{
			to = lt[pos].pos[i];
			ADD_TE_B(player, te, pos, to, in);
		}
		// E
		for(i = 0;i < rt[pos].num;i++)
		{
			to = rt[pos].pos[i];
			ADD_TE_B(player, te, pos, to, in);
		}
		// 
		for(i = 0;i < lb[pos].num;i++)
		{
			to = lb[pos].pos[i];
			ADD_TE_B(player, te, pos, to, in);
		}
		// E
		for(i = 0;i < rb[pos].num;i++)
		{
			to = rb[pos].pos[i];
			ADD_TE_B(player, te, pos, to, in);
		}
	};

	return num;
};

// posɂ̈ړ𐶐
int gen_moves_pos(int player, struct kyokumen_t * in, struct te_t * te, int pos)
{
	int num = 0;

	// ̋
	if(    (player == 0 && in->kifu[pos] > 0)
		|| (player == 1 && in->kifu[pos] < 0)
		)
	{
		int koma = abs(in->kifu[pos]);

		switch(koma)
		{
		case KOMA_FU:
			num += add_te(player, in, ATTACK_FU, pos, &te[num]);
			break;
		case KOMA_KE:
			num += add_te(player, in, ATTACK_KE, pos, &te[num]);
			break;
		case KOMA_GI:
			num += add_te(player, in, ATTACK_GI, pos, &te[num]);
			break;
		case KOMA_KI:
		case KOMA_TO:
		case KOMA_NY:
		case KOMA_NK:
		case KOMA_NG:
			num += add_te(player, in, ATTACK_KI, pos, &te[num]);
			break;
		case KOMA_UM:
			num += add_te(player, in, ATTACK_UM, pos, &te[num]);
			num += add_te_bishop(player, in, ATTACK_OU, pos, &te[num]);
			break;
		case KOMA_RY:
			num += add_te(player, in, ATTACK_RY, pos, &te[num]);
			num += add_te_rook(player, in, ATTACK_OU, pos, &te[num]);
			break;
		case KOMA_OU:
			num += add_te(player, in, ATTACK_OU, pos, &te[num]);
			break;
		case KOMA_KY:
			num += add_te_lance(player, in, ATTACK_OU, pos, &te[num]);
			break;
		case KOMA_HI:
			num += add_te_rook(player, in, ATTACK_OU, pos, &te[num]);
			break;
		case KOMA_KA:
			num += add_te_bishop(player, in, ATTACK_OU, pos, &te[num]);
			break;
			
		};
	}

	return num;
};

// SĂ̎w𐶐
int gen_all_moves(int player, struct kyokumen_t * in, struct te_t * te)
{
	int num = 0;
	int pos;

	// ړ
	for(pos = 0;pos < 81;pos++)
	{
		num += gen_moves_pos(player, in, &te[num], pos);
	}
	// ł
	num += gen_drop(player, in, &te[num]);

	return num;
}



#endif _GENMOVES_
