//
//@@ǖʌ`
//

#ifndef _KYOKUMEN_
#define _KYOKUMEN_


// 64bit^̒`
typedef unsigned __int64 uint64;

//@̎ނ̒萔
#define KOMA_FU		1
#define KOMA_KY		2
#define KOMA_KE		3
#define KOMA_GI		4
#define KOMA_KI		5
#define KOMA_KA		6
#define KOMA_HI		7
#define KOMA_OU		8
#define KOMA_TO		9
#define KOMA_NY		10
#define KOMA_NK		11
#define KOMA_NG		12
#define KOMA_UM		13
#define KOMA_RY		14

// ̉l
#define V_FU	87
#define V_KY	232
#define V_KE	257
#define V_GI	369
#define V_KI	444
#define V_KA	569
#define V_HI	642
#define V_OU	15000
#define V_TO	534
#define V_NY	488
#define V_NK	519
#define V_NG	485
#define V_UM	827
#define V_RY	945

// ̉l̃e[u
// koma_value[14 + ]ŎQ
int koma_value[] =
{
	-V_RY,
	-V_UM, 
	-V_NG, 
	-V_NK, 
	-V_NY, 
	-V_TO, 
	-V_OU, 
	-V_HI, 
	-V_KA, 
	-V_KI, 
	-V_GI, 
	-V_KE, 
	-V_KY, 
	-V_FU, 
	    0,
  	 V_FU, 
	 V_KY, 
	 V_KE, 
	 V_GI, 
	 V_KI, 
	 V_KA, 
	 V_HI, 
	 V_OU, 
	 V_TO, 
	 V_NY, 
	 V_NK, 
	 V_NG, 
	 V_UM, 
	 V_RY
};

// Ƃ̒l
int koma_take_value[] =
{
	-V_RY-V_HI,
	-V_UM-V_KA, 
	-V_NG-V_GI, 
	-V_NK-V_KE, 
	-V_NY-V_KY, 
	-V_TO-V_FU, 
	-V_OU, 
	-V_HI-V_HI, 
	-V_KA-V_KA, 
	-V_KI-V_KI, 
	-V_GI-V_GI, 
	-V_KE-V_KE, 
	-V_KY-V_KY, 
	-V_FU-V_FU, 
	    0,
  	 V_FU+V_FU, 
	 V_KY+V_KY, 
	 V_KE+V_KE, 
	 V_GI+V_GI, 
	 V_KI+V_KI, 
	 V_KA+V_KA, 
	 V_HI+V_HI, 
	 V_OU, 
	 V_TO+V_FU, 
	 V_NY+V_KY, 
	 V_NK+V_KE, 
	 V_NG+V_GI, 
	 V_UM+V_KA, 
	 V_RY+V_HI
};

// Ƃ̒l
int koma_nari_value[] =
{
	    0,
	    0,
	    0,
	    0,
	    0,
	    0,
	    0,
	 -V_RY+V_HI, 
     -V_UM+V_KA, 
	    0,
	 -V_NG+V_GI, 
	 -V_NK+V_KE, 
	 -V_NY+V_KY, 
  	 -V_TO+V_FU, 
	    0,
  	 V_TO-V_FU, 
	 V_NY-V_KY, 
	 V_NK-V_KE, 
	 V_NG-V_GI, 
	 0,
	 V_UM-V_KA, 
	 V_RY-V_HI, 
	 0,
	 0,
	 0,
	 0,
	 0,
	 0,
	 0,
};

// ǖʂ̃f[^\
struct kyokumen_t
{
	// Ֆʁ{ijpj
	char kifu[81 + 14];
	// ̈ʒu
	char king_pos[2];
	// nbVL[
	uint64 hash_key;
	// ]
	int material;
};



// w
struct te_t
{
	char from;		// ړ(-6`81)BA}CiX̂Ƃ͋uƂӖi-1͕uj
	char to;		// ړ(0`81)
	char koma;		// ̎ށBpvm[h\pAȂĂB
	char nari;		// ۂ
	char cap;		// 肩ۂ
	int  v;			// ̕]lBI[_OpB

	// \[g邽߂ɒ`
	bool operator < (const te_t & ref) const 
	{
		return ref.v < v;
	}
	// ̈v̒`BړAړ悪v΂悢Buꍇ͕͐svB
	bool operator == (const te_t & ref) const 
	{
		return 
			(ref.from >= 0 && ref.from == from && ref.to == to && ref.nari == nari) ||
			(ref.from <  0 && ref.from == from && ref.to == to)			
			;
	}
};

// z񂩂AՖʏ쐬
void set_kyokumen(struct kyokumen_t * kyokumen, char *kifu)
{
	memcpy(kyokumen->kifu, kifu, 81 + 14);

	// ̈ʒu
	int pos;
	for(pos = 0;pos < 81;pos++)
	{
		if(kifu[pos] ==  KOMA_OU)
			kyokumen->king_pos[0] = pos;
		if(kifu[pos] == -KOMA_OU)
			kyokumen->king_pos[1] = pos;
	}
};


#endif _KYOKUMEN_
