//
//  @C[`
//

#ifndef _SHOGI_
#define _SHOGI_

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>


#ifdef _WIN32
#include <windows.h>
#include <process.h>
#else
#include "WinAPI.h"
#endif

#include "kyokumen.h"
#include "io.h"
#include "search.h"

int proc_time;		// Jňoߎ[msec]


// Q[̏
void init_shogi()
{
	char init_kifu[] =
	{

		-2 ,-3 ,-4 ,-5 ,-8 ,-5 ,-4 ,-3 ,-2 ,
		+0 ,-7 ,+0 ,+0 , 0 ,+0 ,+0 ,-6 ,+0 ,
		-1 ,-1 ,-1 ,-1 ,-1 ,-1 ,-1 ,-1 ,-1 ,
		+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 , 0 ,+0 ,
		+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,
		+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,
		+1 ,+1 ,+1 ,+1 ,+1 ,+1 ,+1 ,+1 ,+1 ,
		+0 ,+6 ,+0 ,+0 ,+0 ,+0 ,+0 ,+7 ,+0 ,
		+2 ,+3 ,+4 ,+5 ,+8 ,+5 ,+4 ,+3 ,+2 ,
		0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 

	};
	// ee[u
	init_attack();
	init_hash_key();
	tesu = 0;
	// ǖʐݒ
	set_kyokumen(&ptree, init_kifu);
	set_hash(ptree);
	// 
	proc_time = 0;
};


void exit_shogi()
{

};


// USI瑗Ă̏𕪊
int get_next_txt(const char *buf, int len, int n, char *txt)
{
	int c = 0, i;
	for(i = n;i <= len;i++)
	{
		if(buf[i] != ' ' && buf[i] != '\n' && buf[i] != '\0')
		{
			txt[c] = buf[i];
			c++;
		} else {
			txt[c] = '\0';
			return i + 1;
		};
	};
	return -1;
};

// USI瑗Ă̏񂩂A݂̋ǖʂ𐶐
void make_moves_from_usi(const char *buf, int len)
{
	int n = 0;
	char txt[256];
	n = get_next_txt(buf, len, n, txt);
	n = get_next_txt(buf, len, n, txt);
	n = get_next_txt(buf, len, n, txt);

	// ǖʁij
	char init_kifu[] =
	{

		-2 ,-3 ,-4 ,-5 ,-8 ,-5 ,-4 ,-3 ,-2 ,
		+0 ,-7 ,+0 ,+0 , 0 ,+0 ,+0 ,-6 ,+0 ,
		-1 ,-1 ,-1 ,-1 ,-1 ,-1 ,-1 ,-1 ,-1 ,
		+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 , 0 ,+0 ,
		+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,
		+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,
		+1 ,+1 ,+1 ,+1 ,+1 ,+1 ,+1 ,+1 ,+1 ,
		+0 ,+6 ,+0 ,+0 ,+0 ,+0 ,+0 ,+7 ,+0 ,
		+2 ,+3 ,+4 ,+5 ,+8 ,+5 ,+4 ,+3 ,+2 ,
		0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 

	};
	tesu = 0;
	// ̋ǖʃf[^kyokumen_tɕϊ
	set_kyokumen(&ptree, init_kifu);
	set_hash(ptree);

	int player = 0;
	while(n != -1 && txt[0] !='\0')
	{
		txt[0] = '\0';
		n = get_next_txt(buf, len, n, txt);
		if(n != -1 && txt[0] !='\0')
		{
			int from, to, nari;

			nari = 0;
			if(txt[1] == '*')
			{
				// ł
				from = 0;
				int i;
				char name1[] = {'P', 'L', 'N', 'S', 'G', 'B', 'R', 'K'};
				char name2[] = {'p', 'l', 'n', 's', 'g', 'b', 'r', 'k'};
				for(i = 0;i < 8;i++)
				{
					if(txt[0] == name1[i] || txt[0] == name2[i])
						break;
				};
				from = -i-1;
				to   = (8 - (txt[2] - '1'))  + (txt[3] - 'a') * 9;
				nari = 0;
			} else if(txt[4] == '+')
			{
				from = (8 - (txt[0] - '1'))  + (txt[1] - 'a') * 9;
				to   = (8 - (txt[2] - '1'))  + (txt[3] - 'a') * 9;
				nari = 1;
			} else {
				from = (8 - (txt[0] - '1'))  + (txt[1] - 'a') * 9;
				to   = (8 - (txt[2] - '1'))  + (txt[3] - 'a') * 9;
				nari = 0;
			}
			te_t te;
			te.from = from;
			te.to   = to;
			te.nari = nari;
			make_move(player, &ptree, &te);
			tesu++;
			player = 1 - player;
		};
	}
};

// ̏USI̕ɕϊ
char * te2usi(te_t & in)
{
	static char ret[256];

	char b[256];
	// touryou
	if(in.from == -10)
	{
		sprintf(ret, "resign");
		return ret;
	};
	// best
	int x1, y1, x2, y2;
	if(in.from >= 0)
	{
		// ̈ړ
		x1 = 8 - in.from % 9;
		y1 = in.from / 9;
		x2 = 8 - in.to % 9;
		y2 = in.to / 9;
		// 邩H
		if(in.nari)
			sprintf(b, "%c%c%c%c+", '1'+x1, 'a'+y1, '1'+x2, 'a'+y2);
		else
			sprintf(b, "%c%c%c%c", '1'+x1, 'a'+y1, '1'+x2, 'a'+y2);
	} else {
		// u
		x2 = 8 - in.to % 9;
		y2 = in.to / 9;
		int type = -in.from - 1;
		char name[] = {'P', 'L', 'N', 'S', 'G', 'B', 'R', 'K'};
		sprintf(b, "%c*%c%c", name[type], '1'+x2, 'a'+y2);
	}

	sprintf(ret, "%s", b);

	return ret;
};

//
//  vl[`s
//
char *think_usi()
{

	int player = tesu % 2;
	DWORD t0 = GetTickCount();
	search_node = 0;

	int max_it;

	//
	//  ԊǗGc莞Ԃɍ킹āAvlԂݒ
	//


	// 3bTɐݒ
	max_it = 15;
	TIMEOUT = 2800;

	/*
	// 15ݒ̏ꍇ:
	if(proc_time > (1000 * 60 * 14))
	{
		max_it  = 10;
		TIMEOUT = 800;
	} else if(proc_time > (1000 * 60 * 11))
	{
		max_it  = 12;
		TIMEOUT = 8800;
	} else 
	{
		max_it = 12;
		TIMEOUT = 17800;
	}
	*/



	int i, j;

	// L[APV̏
	for(i = 0;i < 32;i++)
	{
		killer1[i].from = -10;
		killer2[i].from = -10;
		for(j = 0;j < 32;j++)
			pv_node[i][j].from = -10;
	}


	// T
	finterrupt = 0;
	init_histry();
	ptree.material = material(0, ptree);
	T0 = ::GetTickCount();
	// Ts
	int stand_pat = evaluate(player, ptree) / 32;
	int value         = iterate(player, VMIN, VMAX, max_it * INC_PLY, 0, 0, stand_pat);
	// i߂
	make_move(player, &ptree, &pv_node[0][0]);
	// Oo
//	out_kyokumen(ptree);

	// 萔𑝂₷
	tesu++;

	// c莞Ԃ𐄒
	int dt = (::GetTickCount() - t0);
	proc_time += (dt - dt % 1000);

	// 𕶎ɕϊUSIɑ
	return te2usi(pv_node[0][0]);
}


//
// [hsBł͂ȂAVSRelease or DebugŎsꍇ͂Ă΂
//
void kentou()
{

	// ǖʃf[^B
	// ړIɉĕςĂB
	char init_kifu[] =
	{
		+0 ,+0 ,+11,-4 ,+0 ,-5 ,+0 ,-3 ,-2 ,
		+13,+14,-3 ,+0 ,-8 ,+0 ,-4 ,+0 ,+0 ,
		-2 ,+0 ,-1 ,-1 ,-1 ,-1 ,+0 ,+0 ,-1 ,
		-1 ,+0 ,+0 ,+0 ,+0 ,+0 ,-1 ,-1 ,+0 ,
		+0 ,+0 ,+1 ,+0 ,+0 ,+0 ,+0 ,+0 ,+0 ,
		+1 ,+0 ,+0 ,+0 ,+0 ,+1 ,+0 ,+0 ,+0 ,
		+2 ,+0 ,+0 ,+0 ,+0 ,+0 ,+1 ,+1 ,+1 ,
		+0 ,+0 ,-10,+0 ,+0 ,+0 ,+4 ,-5 ,-14,
		+8 ,+0 ,+0 ,+0 ,+0 ,+6 , 0 ,+3 ,+0 ,
		3, 0, 0, 1, 1, 0, 0, 
		1, 0, 0, 0, 1, 0, 0, 
	};

	init_shogi();

	int player = 1;
	search_node = 0;
	tesu = 0;
	set_kyokumen(&ptree, init_kifu);
	set_hash(ptree);

	int t;
	//
	// 128B݂Ɏi߂
	//
	print_kyokumen(&ptree);
	for(t = 0;t < 128;t++)
	{

		finterrupt = 0;
		init_histry();
		ptree.material = material(0, ptree);

		T0 = ::GetTickCount();
		TIMEOUT = 1000000;
		int stand_pat = evaluate(player, ptree) / 32;
		int value     = iterate(player, VMIN, VMAX, 10 * INC_PLY, 0, 0, stand_pat);

		if(pv_node[0][0].from == -10)
			break;

		make_move(player, &ptree, &pv_node[0][0]);
		print_kyokumen(&ptree);
		player = 1 - player;

		getchar();
	}
	getchar();

};

#endif _SHOGI_
