//
//
//

#ifndef _ATTACK_
#define _ATTACK_

struct attack_t 
{
	char num;
	char pos[16];
};

#define KOMA_FU		1
#define KOMA_KY		2
#define KOMA_KE		3
#define KOMA_GI		4
#define KOMA_KI		5
#define KOMA_KA		6
#define KOMA_HI		7
#define KOMA_OU		8
#define KOMA_TO		9
#define KOMA_NY		10
#define KOMA_NK		11
#define KOMA_NG		12
#define KOMA_UM		13
#define KOMA_RY		14
#define KOMA_NONE	15

#define ATTACK_FU 0
#define ATTACK_KE 1
#define ATTACK_GI 2
#define ATTACK_KI 3
#define ATTACK_OU 4
#define ATTACK_UM 5
#define ATTACK_RY 6
#define ATTACK_KY 7
#define ATTACK_KA 8
#define ATTACK_HI 9

// 킩AΉ闘̃CfbNX֕ϊe[u
char koma2attack[] = {-1, 0, 0, 1, 2, 3, 6, 5, 4, 3, 3, 3, 3, 4, 4, -1};
// Eʒu̗
struct attack_t attack_koma[2][7][81];
// posɗ\}X̏
// ї͏Bő10
struct attack_t attack_neighbor25[2][81];
// PQɗۂ̏
char attack_koma_2pos[2][16][81][81];
// Ȃ邩ۂ
char   nari_koma[2][16][81];
// 钆SAEAAEÃ}Ẍʒuۑf[^(p̈ړp)
// ͊ȒPȃ[vŉ\A΂ߕ͂łȂ̂Ńe[uɕۑĂ
struct attack_t ll[81];
struct attack_t rr[81];
struct attack_t tt[81];
struct attack_t bb[81];
struct attack_t lt[81];
struct attack_t rt[81];
struct attack_t lb[81];
struct attack_t rb[81];

// Q̈ʒu֌W
#define REL_NONE	0
#define REL_LANCE	1
#define REL_ROOK	2
#define REL_BISHOP	4
char    rel_2koma[2][81][81];


//
//  e[u돉
//
void init_attack()
{
	int pos, pos2, x, y, sx, sy, tx, ty;
	int nari, bx, by;
	int player;
	int i, n, k;

	struct attack_t dat[] = 
	{
		{1, -9},
		{2, -9 * 2 - 1, -9 * 2 + 1},
		{5, -9 * 1 - 1, -9 * 1, -9 * 1 + 1, 9 * 1 - 1, 9 * 1 + 1},
		{6, -9 * 1 - 1, -9 * 1, -9 * 1 + 1, -1, 1, 9 * 1},
		{8, -10, -9, -8, -1, 1, 8, 9, 10},
		{4, -1, 1, -9, 9},
		{4, -9 * 1 - 1, -9 * 1 + 1, 9 * 1 - 1, 9 * 1 + 1}
	};

	for(player = 0;player < 2;player++)
	{
		for(pos = 0;pos < 81;pos++)
		{
			x = pos % 9;
			y = pos / 9;
			bx = x;
			by = y;
			if(player == 1)
				by = 8 - y;
			for(i = 0;i < 7;i++)
			{
				k = 0;
				for(n = 0;n < dat[i].num;n++)
				{
					sy = (dat[i].pos[n] + 82) / 9 - 9;
					sx = (dat[i].pos[n] + 82) % 9 - 1;
					if(player == 1)
						sy = -sy;
					tx = x + sx;
					ty = y + sy;

					if(tx >= 0 && tx <= 8 && ty >= 0 && ty <= 8)
					{
						attack_koma[player][i][pos].pos[k++] = tx + ty * 9;
					}
				};
				attack_koma[player][i][pos].num  = k;
			}; // i
		};// pos
	};// player


	// ̐蔻
	for(player = 0;player < 2;player++)
	{
		for(pos = 0;pos < 81;pos++)
		{
			x = pos % 9;
			y = pos / 9;
			bx = x;
			by = y;
			if(player == 1)
				by = 8 - y;
			for(i = 0;i < 16;i++)
			{
				nari = 0;
				if(by <= 2)
				{
					if(i == KOMA_FU || i == KOMA_KY || i ==KOMA_KE || i == KOMA_GI || i == KOMA_HI || i == KOMA_KA)
						nari = 1;
				}
				// ΐӏ
				if(by <= 2 &&  (i == KOMA_KY))
					nari = 2;
				if(by <= 1 &&  (i == KOMA_KE))
					nari = 2;
				if(by <= 2 &&  (i == KOMA_FU))
					nari = 2;

				nari_koma[player][i][pos] = nari;
			}
		}
	}

	// PQɗۂ̏
	// char attack_koma_2pos[2][15][81][81];
	int to;
	for(player = 0;player < 2;player++)
	{
		for(i = 0;i < 16;i++)
		{
			int ai = koma2attack[i];

			for(pos = 0;pos < 81;pos++)
			{
				for(to = 0;to < 81;to++)
				{
					int ret = 0;

					if(ai != -1)
					{
						for(k = 0;k < attack_koma[player][ai][pos].num;k++)
						{
							if(attack_koma[player][ai][pos].pos[k] == to)
							{
								ret = 1;
								break;
							};
						};
					}
					attack_koma_2pos[player][i][pos][to] = ret;
				};// to
			};// pos
		};// i
	};// player

	// posɗ\}X̏
	// ї͏Bő10
	// struct attack_t attack_neighbor25[2][81];
	for(player = 0;player < 2;player++)
	{
		for(pos = 0;pos < 81;pos++)
		{
			k = 0;
			x = pos % 9;
			y = pos / 9;
			for(sy = -1;sy <= 1;sy++)
			{
				for(sx = -1;sx <= 1;sx++)
				{
					tx = x + sx; 
					ty = y + sy; 
					if(tx >= 0 && tx <= 8 && ty >= 0 && ty <= 8)
					{
						// posɗ肦
						attack_neighbor25[player][pos].pos[k] = tx + ty * 9;
						k++;
					};
				};// sx
			};// sy
			// jñP[Xǉ
			if(player == 0)
				ty = y - 2;
			else
				ty = y + 2;
			tx = x + 1;
			if(tx >= 0 && tx <= 8 && ty >= 0 && ty <= 8)
			{
				// posɗ肦
				attack_neighbor25[player][pos].pos[k] = tx + ty * 9;
				k++;
			};
			tx = x - 1;
			if(tx >= 0 && tx <= 8 && ty >= 0 && ty <= 8)
			{
				// posɗ肦
				attack_neighbor25[player][pos].pos[k] = tx + ty * 9;
				k++;
			};
			// jñP[Xǉ
			attack_neighbor25[player][pos].num = k;
		}
	}


	// 2̈ʒu֌W
	for(player = 0;player < 2;player++)
	{
		for(pos = 0;pos < 81;pos++)
		{
			x = pos % 9;
			y = pos / 9;
			for(pos2 = 0;pos2 < 81;pos2++)
			{
				int x2 = pos2 % 9;
				int y2 = pos2 / 9;

				rel_2koma[player][pos][pos2] = 0;
				if(x == x2 && ((y > y2 && player == 0) || (y < y2 && player == 1))  )
				{
					rel_2koma[player][pos][pos2] = REL_LANCE;
				};
				if(x == x2 && ((y < y2 && player == 0) || (y > y2 && player == 1))  )
				{
					rel_2koma[player][pos][pos2] = REL_ROOK;
				};
				if(x != x2 &&  y == y2)
				{
					rel_2koma[player][pos][pos2] = REL_ROOK;
				};
				// ȂȂ߂ɂ
				int dx = x - x2;
				if(dx > 0 && y2 + dx == y)
					rel_2koma[player][pos][pos2] = REL_BISHOP;
				else if(dx > 0 && y2 - dx == y)
					rel_2koma[player][pos][pos2] = REL_BISHOP;
				else if(dx < 0 && y2 + dx == y)
					rel_2koma[player][pos][pos2] = REL_BISHOP;
				else if(dx < 0 && y2 - dx == y)
					rel_2koma[player][pos][pos2] = REL_BISHOP;


			};
		};
	};

// 钆SAEAAEÃ}Ẍʒuۑf[^(p̈ړp)
// ͊ȒPȃ[vŉ\A΂ߕ͂łȂ̂Ńe[uɕۑĂ
	for(pos = 0;pos < 81;pos++)
	{
		int sx, sy;
		x = pos % 9;
		y = pos / 9;
		int n;

		// 
		n = 0;
		for(sy = y, sx = x - 1;sx >= 0;)
		{
			if(sx >= 0 && sx <= 8 && sy >= 0&& sy <= 8)
			{
				ll[pos].pos[n] = sx + sy * 9; 
				n++;
			};
			sx--;
		};
		ll[pos].num = n;
		// E
		n = 0;
		for(sy = y, sx = x + 1;sx <= 8;)
		{
			if(sx >= 0 && sx <= 8 && sy >= 0&& sy <= 8)
			{
				rr[pos].pos[n] = sx + sy * 9; 
				n++;
			};
			sx++;
		};
		rr[pos].num = n;
		// 
		n = 0;
		for(sy = y - 1, sx = x;sy >= 0;)
		{
			if(sx >= 0 && sx <= 8 && sy >= 0&& sy <= 8)
			{
				tt[pos].pos[n] = sx + sy * 9; 
				n++;
			};
			sy--;
		};
		tt[pos].num = n;
		// 
		n = 0;
		for(sy = y + 1, sx = x;sy <= 8;)
		{
			if(sx >= 0 && sx <= 8 && sy >= 0&& sy <= 8)
			{
				bb[pos].pos[n] = sx + sy * 9; 
				n++;
			};
			sy++;
		};
		bb[pos].num = n;

		// 
		n = 0;
		for(sy = y - 1, sx = x - 1;sx >= 0;)
		{
			if(sx >= 0 && sx <= 8 && sy >= 0&& sy <= 8)
			{
				lt[pos].pos[n] = sx + sy * 9; 
				n++;
			};
			sx--;
			sy--;
		};
		lt[pos].num = n;
		// 
		n = 0;
		for(sy = y + 1, sx = x - 1;sx >= 0;)
		{
			if(sx >= 0 && sx <= 8 && sy >= 0&& sy <= 8)
			{
				lb[pos].pos[n] = sx + sy * 9; 
				n++;
			};
			sx--;
			sy++;
		};
		lb[pos].num = n;
		// E
		n = 0;
		for(sy = y - 1, sx = x + 1;sx <= 8;)
		{
			if(sx >= 0 && sx <= 8 && sy >= 0&& sy <= 8)
			{
				rt[pos].pos[n] = sx + sy * 9; 
				n++;
			};
			sx++;
			sy--;
		};
		rt[pos].num = n;
		// E
		n = 0;
		for(sy = y + 1, sx = x + 1;sx <= 8;)
		{
			if(sx >= 0 && sx <= 8 && sy >= 0&& sy <= 8)
			{
				rb[pos].pos[n] = sx + sy * 9; 
				n++;
			};
			sx++;
			sy++;
		};
		rb[pos].num = n;

	};

};


// get_attack_to_pos(player, ptree, pos)
// }Xւ̗̗̑L(̈ʒuԂ)𔻒
// ͂̃}Xڂ̎ɗ
// ㉺E΂߂ǂApȂׂ
char f_rook_lance_w[] = 
{
0, //  0 bdragon
0, //  1 bhorse
0, //  2 bng
0, //  3 bnk
0, //  4 bny
0, //  5 bto
0, //  6 bking
0, //  7 brook
0, //  8 bbishop
0, //  9 bgold
0, // 10 bsilver
0, // 11 bknight 
0, // 12 blance
0, // 13 bpawn
0, // 14 none
0, // 15 wpawn
1, // 16 wlance
0, // 17 wknight 
0, // 18 wsilver
0, // 19 wgold
0, // 20 wbishop
1, // 21 wrook
0, // 22 wking
0, // 23 wto
0, // 24 wny
0, // 25 wnk
0, // 26 wng
0, // 27 whorse
1, // 28 wdragon
};
char f_rook_lance_b[] = 
{
1, //  0 bdragon
0, //  1 bhorse
0, //  2 bng
0, //  3 bnk
0, //  4 bny
0, //  5 bto
0, //  6 bking
1, //  7 brook
0, //  8 bbishop
0, //  9 bgold
0, // 10 bsilver
0, // 11 bknight 
1, // 12 blance
0, // 13 bpawn
0, // 14 none
0, // 15 wpawn
0, // 16 wlance
0, // 17 wknight 
0, // 18 wsilver
0, // 19 wgold
0, // 20 wbishop
0, // 21 wrook
0, // 22 wking
0, // 23 wto
0, // 24 wny
0, // 25 wnk
0, // 26 wng
0, // 27 whorse
0, // 28 wdragon
};
char f_rook_w[] = 
{
0, //  0 bdragon
0, //  1 bhorse
0, //  2 bng
0, //  3 bnk
0, //  4 bny
0, //  5 bto
0, //  6 bking
0, //  7 brook
0, //  8 bbishop
0, //  9 bgold
0, // 10 bsilver
0, // 11 bknight 
0, // 12 blance
0, // 13 bpawn
0, // 14 none
0, // 15 wpawn
0, // 16 wlance
0, // 17 wknight 
0, // 18 wsilver
0, // 19 wgold
0, // 20 wbishop
1, // 21 wrook
0, // 22 wking
0, // 23 wto
0, // 24 wny
0, // 25 wnk
0, // 26 wng
0, // 27 whorse
1, // 28 wdragon
};
char f_rook_b[] = 
{
1, //  0 bdragon
0, //  1 bhorse
0, //  2 bng
0, //  3 bnk
0, //  4 bny
0, //  5 bto
0, //  6 bking
1, //  7 brook
0, //  8 bbishop
0, //  9 bgold
0, // 10 bsilver
0, // 11 bknight 
0, // 12 blance
0, // 13 bpawn
0, // 14 none
0, // 15 wpawn
0, // 16 wlance
0, // 17 wknight 
0, // 18 wsilver
0, // 19 wgold
0, // 20 wbishop
0, // 21 wrook
0, // 22 wking
0, // 23 wto
0, // 24 wny
0, // 25 wnk
0, // 26 wng
0, // 27 whorse
0, // 28 wdragon
};
char f_bishop_b[] = 
{
0, //  0 bdragon
1, //  1 bhorse
0, //  2 bng
0, //  3 bnk
0, //  4 bny
0, //  5 bto
0, //  6 bking
0, //  7 brook
1, //  8 bbishop
0, //  9 bgold
0, // 10 bsilver
0, // 11 bknight 
0, // 12 blance
0, // 13 bpawn
0, // 14 none
0, // 15 wpawn
0, // 16 wlance
0, // 17 wknight 
0, // 18 wsilver
0, // 19 wgold
0, // 20 wbishop
0, // 21 wrook
0, // 22 wking
0, // 23 wto
0, // 24 wny
0, // 25 wnk
0, // 26 wng
0, // 27 whorse
0, // 28 wdragon
};

char f_bishop_w[] = 
{
0, //  0 bdragon
0, //  1 bhorse
0, //  2 bng
0, //  3 bnk
0, //  4 bny
0, //  5 bto
0, //  6 bking
0, //  7 brook
0, //  8 bbishop
0, //  9 bgold
0, // 10 bsilver
0, // 11 bknight 
0, // 12 blance
0, // 13 bpawn
0, // 14 none
0, // 15 wpawn
0, // 16 wlance
0, // 17 wknight 
0, // 18 wsilver
0, // 19 wgold
1, // 20 wbishop
0, // 21 wrook
0, // 22 wking
0, // 23 wto
0, // 24 wny
0, // 25 wnk
0, // 26 wng
1, // 27 whorse
0, // 28 wdragon
};

#define IS_ROOK_LANCE_B(to)			\
if(f_rook_lance_b[in.kifu[to]+14])	\
	return to;						\
else if(in.kifu[to] != 0)			\
    break;							\

#define IS_ROOK_B(to)				\
if(f_rook_b[in.kifu[to]+14])		\
	return to;						\
else if(in.kifu[to] != 0)			\
    break;							\

#define IS_BISHOP_B(to)				\
if(f_bishop_b[in.kifu[to]+14])		\
	return to;						\
else if(in.kifu[to] != 0)			\
    break;							\

#define IS_ROOK_LANCE_W(to)			\
if(f_rook_lance_w[in.kifu[to]+14])	\
	return to;						\
else if(in.kifu[to] != 0)			\
    break;							\

#define IS_ROOK_W(to)				\
if(f_rook_w[in.kifu[to]+14])		\
	return to;						\
else if(in.kifu[to] != 0)			\
    break;							\

#define IS_BISHOP_W(to)				\
if(f_bishop_w[in.kifu[to]+14])		\
	return to;						\
else if(in.kifu[to] != 0)			\
    break;							\


//
// posɗ̈ʒuԂ
//
int get_attack_to_pos(int player, kyokumen_t & in, int pos)
{
	int ret = -1;
	int n, koma;
	int to;
	attack_t & ref = attack_neighbor25[player][pos];

	if(player == 0)
	{
		// ͂̃}Xڂ̎ɗ
		for(n = 0;n < ref.num;n++)
		{
			// ߖT}X̋
			koma = in.kifu[ref.pos[n]];
			// ̋łAposɗ
			if(koma < 0 && attack_koma_2pos[player][-koma][pos][ref.pos[n]])
			{
				// ʒuԂ
				return ref.pos[n];
			}
		};
		// pos㉺E΂߂ǂApȂׂ

		int i;
		// (ԂԂ邩H)
		for(i = 0;i < tt[pos].num;i++)
		{
			to = tt[pos].pos[i];
			IS_ROOK_LANCE_B(to);
		}
		// 
		for(i = 0;i < bb[pos].num;i++)
		{
			to = bb[pos].pos[i];
			IS_ROOK_B(to);
		}
		// 
		for(i = 0;i < ll[pos].num;i++)
		{
			to = ll[pos].pos[i];
			IS_ROOK_B(to);
		}
		// E
		for(i = 0;i < rr[pos].num;i++)
		{
			to = rr[pos].pos[i];
			IS_ROOK_B(to);
		}
		// 
		for(i = 0;i < lt[pos].num;i++)
		{
			to = lt[pos].pos[i];
			IS_BISHOP_B(to);
		}
		// E
		for(i = 0;i < rt[pos].num;i++)
		{
			to = rt[pos].pos[i];
			IS_BISHOP_B(to);
		}
		// 
		for(i = 0;i < lb[pos].num;i++)
		{
			to = lb[pos].pos[i];
			IS_BISHOP_B(to);
		}
		// E
		for(i = 0;i < rb[pos].num;i++)
		{
			to = rb[pos].pos[i];
			IS_BISHOP_B(to);
		}

	} else {
		// ͂̃}Xڂ̎ɗ
		for(n = 0;n < ref.num;n++)
		{
			// ߖT}X̋
			koma = in.kifu[ref.pos[n]];
			// ̋łAposɗ
			if(koma > 0 && attack_koma_2pos[player][koma][pos][ref.pos[n]])
			{
				// ʒuԂ
				return ref.pos[n];
			}
		};
		// (ԂԂ邩H)
		int i;
		// (ԂԂ邩H)
		for(i = 0;i < tt[pos].num;i++)
		{
			to = tt[pos].pos[i];
			IS_ROOK_W(to);
		}
		// 
		for(i = 0;i < bb[pos].num;i++)
		{
			to = bb[pos].pos[i];
			IS_ROOK_LANCE_W(to);
		}
		// 
		for(i = 0;i < ll[pos].num;i++)
		{
			to = ll[pos].pos[i];
			IS_ROOK_W(to);
		}
		// E
		for(i = 0;i < rr[pos].num;i++)
		{
			to = rr[pos].pos[i];
			IS_ROOK_W(to);
		}


		for(i = 0;i < lt[pos].num;i++)
		{
			to = lt[pos].pos[i];
			IS_BISHOP_W(to);
		}
		// E
		for(i = 0;i < rt[pos].num;i++)
		{
			to = rt[pos].pos[i];
			IS_BISHOP_W(to);
		}
		// 
		for(i = 0;i < lb[pos].num;i++)
		{
			to = lb[pos].pos[i];
			IS_BISHOP_W(to);
		}
		// E
		for(i = 0;i < rb[pos].num;i++)
		{
			to = rb[pos].pos[i];
			IS_BISHOP_W(to);
		}
			
	};

	return ret;
}

// ݉肩ۂ
// is_in_check(player, ptree)
// ̈ʒuget_attack_to_pos
int is_in_check(int player, kyokumen_t & ptree)
{
	return get_attack_to_pos(player, ptree, ptree.king_pos[player]);
}

#define IS_CHECK_MOVE_ROOK_LANCE_W	\
if(in.kifu[to] >= 0)				\
{									\
	if(in.kifu[to] > 0)				\
	{								\
		if(f_rook_lance_w[14+in.kifu[to]])	\
		{ret = 1;goto END_CHECK_MOVE;}\
		break;						\
	}								\
} else break;						\

#define IS_CHECK_MOVE_ROOK_W		\
if(in.kifu[to] >= 0)				\
{									\
	if(in.kifu[to] > 0)				\
	{								\
		if(f_rook_w[14+in.kifu[to]])	\
		{ret = 1;goto END_CHECK_MOVE;}\
		break;						\
	}								\
} else break;						\

#define IS_CHECK_MOVE_BISHOP_W		\
if(in.kifu[to] >= 0)				\
{									\
	if(in.kifu[to] > 0)				\
	{								\
		if(f_bishop_w[14+in.kifu[to]])	\
		{ret = 1;goto END_CHECK_MOVE;}\
		break;						\
	}								\
} else break;						\

#define IS_CHECK_MOVE_ROOK_LANCE_B	\
if(in.kifu[to] <= 0)				\
{									\
	if(in.kifu[to] < 0)				\
	{								\
		if(f_rook_lance_b[14+in.kifu[to]])	\
		{ret = 1;goto END_CHECK_MOVE;}\
		break;						\
	}								\
} else break;						\

#define IS_CHECK_MOVE_ROOK_B		\
if(in.kifu[to] <= 0)				\
{									\
	if(in.kifu[to] < 0)				\
	{								\
		if(f_rook_b[14+in.kifu[to]])	\
		{ret = 1;goto END_CHECK_MOVE;}\
		break;						\
	}								\
} else break;						\

#define IS_CHECK_MOVE_BISHOP_B		\
if(in.kifu[to] <= 0)				\
{									\
	if(in.kifu[to] < 0)				\
	{								\
		if(f_bishop_b[14+in.kifu[to]])	\
		{ret = 1;goto END_CHECK_MOVE;}\
		break;						\
	}								\
} else break;						\


// 肪肩ۂ̔
// is_check_move(player, ptree, te)
// ̋ډ肩
// 𓮂ꍇA̋ʂƂ̔ї֌W`FbN
// R_LANCE = 1, R_ROOK = 2, R_BISHOP = 3
// ї֌WȂA
// 폜āAis_in_check
char to_nari_koma[] = {
0,
KOMA_TO, KOMA_NY, KOMA_NK, KOMA_NG, KOMA_KI, KOMA_UM, KOMA_RY, KOMA_OU, KOMA_TO, KOMA_NY, KOMA_NK, KOMA_NG,KOMA_UM, KOMA_RY
};

int is_check_move(int player, kyokumen_t & in, te_t & te)
{
	int i;
	int koma, to;
	int king_pos = in.king_pos[1 - player];
	int tmp_from, tmp_to;
	int ret = 0;
	int psign;
	if(player == 0)
		psign = 1;
	else
		psign = -1;

	// 
	if(te.from >= 0)
	{
		koma = abs(in.kifu[te.from]);
		if(te.nari)
			koma = to_nari_koma[koma];
	}
	else {
		koma = -te.from;
	}
	// ʂɗ
	if(attack_koma_2pos[player][koma][te.to][king_pos])
	{
		return 1;
	}

	// їɂ锻
	// ړ̋āAїsB
	if(te.from >= 0)
	{
		tmp_from = in.kifu[te.from];
		tmp_to   = in.kifu[te.to];
		in.kifu[te.to]   = koma * psign;
		in.kifu[te.from] = 0;
	} else {
		tmp_to   = in.kifu[te.to];
		in.kifu[te.to]   = koma * psign;
	};

	int rel;
	
	rel = rel_2koma[player][te.from][king_pos];
	// ʂƂ̈ʒu֌W
	if(player == 0)
	{
		if(rel == REL_LANCE)
		{
			// ʂ牺ǂAԂԂΉł
			for(i = 0;i < bb[king_pos].num;i++)
			{
				to = bb[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_LANCE_W;
			}
		} else if(rel == REL_ROOK)
		{
			// ʂǂAԂΉł
			for(i = 0;i < tt[king_pos].num;i++)
			{
				to = tt[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_W;
			}
			// 
			for(i = 0;i < ll[king_pos].num;i++)
			{
				to = ll[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_W;
			}
			// E
			for(i = 0;i < rr[king_pos].num;i++)
			{
				to = rr[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_W;
			}
		} else if(rel == REL_BISHOP)
		{
			// 
			for(i = 0;i < lt[king_pos].num;i++)
			{
				to = lt[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_W;			
			}
			// E
			for(i = 0;i < rt[king_pos].num;i++)
			{
				to = rt[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_W;			
			}
			// 
			for(i = 0;i < lb[king_pos].num;i++)
			{
				to = lb[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_W;			
			}
			// E
			for(i = 0;i < rb[king_pos].num;i++)
			{
				to = rb[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_W;			
			}

		}
	} else {
		if(rel == REL_LANCE)
		{
			// ʂǂAԂԂΉł
			for(i = 0;i < tt[king_pos].num;i++)
			{
				to = tt[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_LANCE_B;
			}
		} else if(rel == REL_ROOK)
		{
			// ʂǂAԂΉł
			for(i = 0;i < bb[king_pos].num;i++)
			{
				to = bb[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_B;
			}
			// 
			for(i = 0;i < ll[king_pos].num;i++)
			{
				to = ll[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_B;
			}
			// E
			for(i = 0;i < rr[king_pos].num;i++)
			{
				to = rr[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_B;
			}

		} else if(rel == REL_BISHOP)
		{
			// 
			int i;
			for(i = 0;i < lt[king_pos].num;i++)
			{
				to = lt[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_B;			
			}
			// E
			for(i = 0;i < rt[king_pos].num;i++)
			{
				to = rt[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_B;			
			}
			// 
			for(i = 0;i < lb[king_pos].num;i++)
			{
				to = lb[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_B;			
			}
			// E
			for(i = 0;i < rb[king_pos].num;i++)
			{
				to = rb[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_B;			
			}
		}
	}
	rel = rel_2koma[player][te.to][king_pos];
	// ʂƂ̈ʒu֌W
	if(player == 0)
	{
		if(rel == REL_LANCE)
		{
			// ʂ牺ǂAԂԂΉł
			for(i = 0;i < bb[king_pos].num;i++)
			{
				to = bb[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_LANCE_W;
			}
		} else if(rel == REL_ROOK)
		{
			// ʂǂAԂΉł
			for(i = 0;i < tt[king_pos].num;i++)
			{
				to = tt[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_W;
			}
			// 
			for(i = 0;i < ll[king_pos].num;i++)
			{
				to = ll[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_W;
			}
			// E
			for(i = 0;i < rr[king_pos].num;i++)
			{
				to = rr[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_W;
			}
		} else if(rel == REL_BISHOP)
		{
			// 
			for(i = 0;i < lt[king_pos].num;i++)
			{
				to = lt[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_W;			
			}
			// E
			for(i = 0;i < rt[king_pos].num;i++)
			{
				to = rt[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_W;			
			}
			// 
			for(i = 0;i < lb[king_pos].num;i++)
			{
				to = lb[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_W;			
			}
			// E
			for(i = 0;i < rb[king_pos].num;i++)
			{
				to = rb[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_W;			
			}

		}
	} else {
		if(rel == REL_LANCE)
		{
			// ʂǂAԂԂΉł
			for(i = 0;i < tt[king_pos].num;i++)
			{
				to = tt[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_LANCE_B;
			}
		} else if(rel == REL_ROOK)
		{
			// ʂǂAԂΉł
			for(i = 0;i < bb[king_pos].num;i++)
			{
				to = bb[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_B;
			}
			// 
			for(i = 0;i < ll[king_pos].num;i++)
			{
				to = ll[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_B;
			}
			// E
			for(i = 0;i < rr[king_pos].num;i++)
			{
				to = rr[king_pos].pos[i];
				IS_CHECK_MOVE_ROOK_B;
			}

		} else if(rel == REL_BISHOP)
		{
			// 
			int i;
			for(i = 0;i < lt[king_pos].num;i++)
			{
				to = lt[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_B;			
			}
			// E
			for(i = 0;i < rt[king_pos].num;i++)
			{
				to = rt[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_B;			
			}
			// 
			for(i = 0;i < lb[king_pos].num;i++)
			{
				to = lb[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_B;			
			}
			// E
			for(i = 0;i < rb[king_pos].num;i++)
			{
				to = rb[king_pos].pos[i];
				IS_CHECK_MOVE_BISHOP_B;			
			}
		}
	}
END_CHECK_MOVE:
	// ߂
	if(te.from >= 0)
	{
		in.kifu[te.from] = tmp_from;
		in.kifu[te.to]   = tmp_to;
	} else {
		in.kifu[te.to]   = tmp_to;
	};

	return ret;
};


#endif _ATTACK_
