//
//  nbV֘A
//
#ifndef _HASH_
#define _HASH_

#include "kyokumen.h"

// nbV\
struct hash_t 
{
	uint64 hash_key;	// nbVL[
	int    value;		// ̋ǖʂ̕]l
	char   rdepth;		// ̂Ƃ̎c[
	char   flag;		// ]l̃^CvFlA^lAl
	te_t   best;		// ̍őP
	te_t   second;		// őPXVO̎
};

// nbṼTCY
#define HASH_MASK	0x4ffff
#define HASH_SIZE	HASH_MASK + 1

// nbṼ^Cv
#define HASH_UPPER  1	// 	
#define HASH_LOWER -1	// 
#define HASH_EXACT  0	// ^l


// nbV̎́FvC[ƂɎĂ
hash_t hash[2][HASH_SIZE];
// EʒuƂ̃nbVl
uint64 hash_value[32][95];

// XOR^
unsigned long xor128_() {
    static unsigned long x=123456789,y=362436069,z=521288629,w=88675123;
    unsigned long t;
    t=(x^(x<<11));
	x=y;y=z;z=w; 
	return( w=(w^(w>>19))^(t^(t>>8)) );
}

// 64bit̐
uint64 xor128()
{
	return xor128_() + (xor128_() << 31);
}

// nbVl̎Q
int hash_probe(int player, uint64 hash_key, int alpha, int beta, int rdepth, hash_t **phash)
{
	int hash_index = hash_key & HASH_MASK;
	*phash = &hash[player][hash_index];

	if((*phash)->hash_key == hash_key)
	{
		// p\ȕiǂ`FbN
		// @݂̋ǖʂ̂̐[Ae[uƓA[
		// A]l
		//   (a)ȉȂ΁A^lł邱
		//   (b)`Ȃ΁A^lł邱
		//   (c)ȏȂ΁A^lł邱
		if( 
			rdepth <= (*phash)->rdepth &&
			(
			   ((*phash)->value <= alpha && (*phash)->flag > 0)
			|| (*phash)->flag == 0
			|| ((*phash)->value  >= beta && (*phash)->flag < 0)
			)
			)
		{
			return 1; 
		}
	}
	return 0;
};

// AʒuƂ̃nbVl
void init_hash_key()
{
	int i, pos;

	for(i = 0;i < 32;i++)
	{
		for(pos = 0;pos < 95;pos++)
		{
			hash_value[i][pos] = xor128();
		};
	};
};

// ǖʂ̃nbVlvZ
void set_hash(kyokumen_t & in)
{
	int pos;
	in.hash_key = 0;
	for(pos = 0;pos < 95;pos++)
	{
		in.hash_key ^= hash_value[14 + in.kifu[pos]][pos];
	}
}

// nbV̓o^
void hash_entry(uint64 hash_key, int player, int value, int alpha, int beta, int rdepth, te_t & te)
{
	int hash_index = hash_key & HASH_MASK;
	hash_t & ref = hash[player][hash_index];

	if(ref.rdepth <= rdepth)
	{
		// o^
		ref.hash_key = hash_key;
		ref.rdepth   = rdepth;
		ref.value    = value;
		ref.second   = ref.best;
		ref.best     = te;

		// o^nbVe̎
		// Ɏ܂Ă΁A̕]l͐mł̂ŁA
		// nbVQƎ́A̕]l̂܂ܕԂ΂悢B
		// ȊÓA^̕]lƈႤ\B
		if(value <= alpha)
		{
			// SĂ̎]ĂA̍ő]lȉꍇ
			ref.flag     = HASH_UPPER;
		} else if(value >= beta)
		{
			// JbgNꍇ
			ref.flag     = HASH_LOWER;
		} else {
			// SĂ̎]āAő]l`Ɏ܂ꍇ
			ref.flag     = HASH_EXACT;
		}
	}

};

#endif _HASH_
