//
//  io֌W
//

#ifndef _IO_
#define _IO_

#include <wincon.h>

#include "kyokumen.h"

void print_kyokumen(struct kyokumen_t * in, int _first = 0)
{
	HANDLE hStdout;
	WORD wAttributes;
	CONSOLE_SCREEN_BUFFER_INFO csbi;//\̂ł 
	hStdout = GetStdHandle(STD_OUTPUT_HANDLE); //hStdout̃R\[XN[obt@csbiɎ擾 

	wAttributes = 15;

	GetConsoleScreenBufferInfo(hStdout, &csbi); 
	SetConsoleTextAttribute(hStdout, wAttributes);

	static struct kyokumen_t prev = {0};
	static int first = 1;


	if(first == 1 || _first == 1)
	{
		prev  = *in;
		first = 0;
	}

	int x, y;
	char name[][3] = {"FU", "KY", "KE", "GI", "KI", "KA", "HI", "OU", "TO", "NA", "NK", "NG", "UM", "RY"};

	printf("   9  8  7  6  5  4  3  2  1\n");
	for(y=0;y<9;y++)
	{
		printf("P%d", y + 1);
		for(x=0;x<9;x++)
		{
			int prev_type = prev.kifu[y * 9 + x];
			int type      = in->kifu[y * 9  + x];
			int player;

			if(prev_type != type)
			{
				wAttributes = BACKGROUND_BLUE | BACKGROUND_INTENSITY;
				SetConsoleTextAttribute(hStdout, wAttributes);
			} else {
				wAttributes = 15;
				SetConsoleTextAttribute(hStdout, wAttributes);
			}
			if(type > 0)player = 0;
			else player = 1;
			type = abs(type);
			if(type == 0)
			{
				printf(" * ");
			} else 
			{
				if(player == 0)
					printf("+");
				else
					printf("-");
				printf(name[type-1]);
			}
		};//x
		printf("\n");
	};//y

	// 
	int hand, i;
	printf("P+");
	// 
	hand = in->kifu[81 + 6];
	for(i = 0;i < hand;i++)
		printf("00HI");
	// p
	hand = in->kifu[81 + 5];
	for(i = 0;i < hand;i++)
		printf("00KA");
	// 
	hand = in->kifu[81 + 4];
	for(i = 0;i < hand;i++)
		printf("00KI");
	// 
	hand = in->kifu[81 + 3];
	for(i = 0;i < hand;i++)
		printf("00GI");
	// j
	hand = in->kifu[81 + 2];
	for(i = 0;i < hand;i++)
		printf("00KE");
	// 
	hand = in->kifu[81 + 1];
	for(i = 0;i < hand;i++)
		printf("00KY");
	// 
	hand = in->kifu[81 + 0];
	for(i = 0;i < hand;i++)
		printf("00FU");
	printf("\n");

	printf("P-");
	// 
	hand = in->kifu[88 + 6];
	for(i = 0;i < hand;i++)
		printf("00HI");
	// p
	hand = in->kifu[88 + 5];
	for(i = 0;i < hand;i++)
		printf("00KA");
	// 
	hand = in->kifu[88 + 4];
	for(i = 0;i < hand;i++)
		printf("00KI");
	// 
	hand = in->kifu[88 + 3];
	for(i = 0;i < hand;i++)
		printf("00GI");
	// j
	hand = in->kifu[88 + 2];
	for(i = 0;i < hand;i++)
		printf("00KE");
	// 
	hand = in->kifu[88 + 1];
	for(i = 0;i < hand;i++)
		printf("00KY");
	// 
	hand = in->kifu[88 + 0];
	for(i = 0;i < hand;i++)
		printf("00FU");
	printf("\n");

	prev = *in;

	wAttributes = 15;
	SetConsoleTextAttribute(hStdout, wAttributes);
}

char * te_name(te_t & te)
{
	static char txt[256];
	int x1, y1, x2, y2;
	char name[][3] = {"FU", "KY", "KE", "GI", "KI", "KA", "HI", "OU", "TO", "NA", "NK", "NG", "UM", "RY"};
	int  koma;

	if(te.from >= 0)
	{
		x1 = 8 - te.from % 9 + 1;
		y1 = te.from / 9 + 1;
		x2 = 8 - te.to % 9 + 1;
		y2 = te.to / 9 + 1;
		koma = abs(te.koma) - 1;
		if(te.nari)
			sprintf(txt, "%d%d%d%d%s!", x1, y1, x2, y2, name[koma]);
		else
			sprintf(txt, "%d%d%d%d%s", x1, y1, x2, y2, name[koma]);
	} else {
		x1 = 0;
		y1 = 0;
		x2 = 8 - te.to % 9 + 1;
		y2 = te.to / 9 + 1;
		koma = -te.from - 1;
		sprintf(txt, "%d%d%d%d%s", x1, y1, x2, y2, name[koma]);
	}

	return txt;

}

void print_te(struct te_t *te, int te_num)
{
	int x1, y1, x2, y2;
	int i;
	char name[][3] = {"FU", "KY", "KE", "GI", "KI", "KA", "HI", "OU", "TO", "NA", "NK", "NG", "UM", "RY"};
	int  koma;

	for(i = 0;i < te_num;i++)
	{
		if(te[i].from > 0)
		{
			x1 = 8 - te[i].from % 9 + 1;
			y1 = te[i].from / 9 + 1;
			x2 = 8 - te[i].to % 9 + 1;
			y2 = te[i].to / 9 + 1;
			koma = abs(te[i].koma) - 1;
			printf("%d%d%d%d%s", x1, y1, x2, y2, name[koma]);
			if(te[i].nari)
				printf("*");
		} else {
			x1 = 0;
			y1 = 0;
			x2 = 8 - te[i].to % 9 + 1;
			y2 = te[i].to / 9 + 1;
			koma = -te[i].from - 1;
			printf("%d%d%d%d%s", x1, y1, x2, y2, name[koma]);

		}
		printf("-");
	}

	printf("\nnum=%d\n", te_num);

}



void out_kyokumen(kyokumen_t & in)
{

	FILE *fp=fopen("./log/log2.txt", "a");
	fprintf(fp, "--------------------------------\n");
	int x, y;
	for(y = 0;y < 9;y++)
	{
		for(x = 0;x < 9;x++)
		{
			fprintf(fp, "%+d", in.kifu[x + y * 9]);
			if(abs(in.kifu[y * 9 + x]) < 10)
				fprintf(fp, " ");
			fprintf(fp, ",");
		};//x
		fprintf(fp, "\n");
	};//y

	int i;
	for(i = 0;i < 7;i++)
		fprintf(fp, "%d, ", in.kifu[81+i]);
	fprintf(fp, "\n");
	for(i = 0;i < 7;i++)
		fprintf(fp, "%d, ", in.kifu[88+i]);
	fprintf(fp, "\n");
	fclose(fp);
}

#endif

