//
//
//
//
#define CUI_MODE

#ifdef _WIN32
#include <windows.h>
#include <process.h>
#else
//#include "WinAPI.h"
#endif

#include <time.h>
#include <string.h>
#include <algorithm>
#include <string>
#include <memory>
#include <queue>


#include "shogi.h"

//GLOBAL======================================================================
bool isStopReceived = false; // stopR}hM
bool canPonder = false; // ǂ݉\
bool canThrow = false; // vlf\ǂ
bool isPonderThink = false; // ǂݎvl
bool isTsumeThink = false; // l𓚎vl

unsigned long thinkStartTime; // vlJn
unsigned long ponderhitReceiveTime = 0; // ponderhitM

unsigned long evaluatedNodes; // KyokumenKomagumi::Evaluate()Ă΂ꂽ
unsigned long hashCount = 0; // nbVɒǉꂽ

unsigned long remainTime = 0; // c莞
unsigned long byoyomiTime = 0; // bǂ݂̎
unsigned long tsumeLimitTime = 0; // l𓚂̐
bool isInfinite = false; // vlԂǂ
int thinkDepthMax = 4; // ǂ݂̍ő[
//GLOBAL======================================================================



//
using namespace std;

#ifdef __GNUC__

#define CRITICAL_SECTION pthread_mutex_t
#define InitializeCriticalSection(a) pthread_mutex_init(a, NULL)
#define EnterCriticalSection(a) pthread_mutex_lock(a)
#define LeaveCriticalSection(a) pthread_mutex_unlock(a)
#define DeleteCriticalSection(a) pthread_mutex_destroy(a)
#define Sleep(a) usleep((a) * 1000)

#endif

queue<string> commandQueue; // MR}hǉ邽߂̃L[

CRITICAL_SECTION cs; // NeBJZNVIuWFNg
// commandQueueɑ΂āAReceiveThread()WaitCommand()
// ɃANZXłȂ悤AcommandQueueɃANZX镔
// NeBJZNVɂB

// R}hM̂߂̊֐BvlłMł悤ɁAXbh炱̊֐ĂяoB
#ifdef _WIN32
void ReceiveThread(void *)
#else
void *ReceiveThread(void *)
#endif
{
	char buf[10000];
	while (true) {
		fgets(buf, 10000, stdin);
		buf[strlen(buf) - 1] = 0; // sR[hB

		if (strncmp(buf, "quit", strlen("quit")) == 0) {
			while (commandQueue.size() > 0) {
				// GWݒ_CAOOKƁAsetoptionquitđĂB
				// ̎Asetoption̓esOexit()Ă΂Ȃ悤AquitR}h
				// OɎMR}hSĎsĂI悤ɂB
				// {́AcommandQueuẽTCY0ƂāAȑÕR}h{
				// sꂽƂۏ؂͂ȂipopŁA܂sỎ\̂ŁjA
				// setoptionɊւĂ͎s200ms邱Ƃ͂Ȃ̂ŁȂ΍􂾂ōς܂
				// ƂɂB
				Sleep(200);
			}
			// IOɃNeBJZNVIuWFNgjB
			DeleteCriticalSection(&cs);
			// quitMGWIB
			exit(0);
		}
		EnterCriticalSection(&cs); // NeBJZNVɓB
		if (strncmp(buf, "stop", strlen("stop")) == 0) {
			isStopReceived = true;
		}
		if (strncmp(buf, "ponderhit", strlen("ponderhit")) == 0) {
			ponderhitReceiveTime = timeGetTime();
		}
		if (strncmp(buf, "gameover", strlen("gameover")) == 0) {
			isStopReceived = true; // ǂݒgameoverĂꍇAvlł؂B
		}
		string commandStr = buf;
		commandQueue.push(commandStr); // R}hL[ɒǉB
		LeaveCriticalSection(&cs); // NeBJZNVoB
	}
}

// MR}hԂB
string WaitCommand()
{
	while (commandQueue.empty()) {
		Sleep(100);
	}
	EnterCriticalSection(&cs); // NeBJZNVɓB
	string commandStr = commandQueue.front(); // L[R}h擾B
	commandQueue.pop(); // L[R}h폜B
	LeaveCriticalSection(&cs); // NeBJZNVoB
	return commandStr;
}

// R}hMXbhJnB
bool BeginThread()
{
#ifdef _WIN32
	uintptr_t hdl = _beginthread(ReceiveThread, 0, NULL);
	return (hdl != -1);
#else
	pthread_t thread;
	int err = pthread_create(&thread , NULL , ReceiveThread , NULL);
	return (err == 0);
#endif
}

int main(int argc, char* argv[])
{
	if(argc > 1 && strncmp(argv[1], "CUI", 3)==0)
	{
		kentou();

		return 0;
	}

	setvbuf(stdin, NULL, _IONBF, 0);
	setvbuf(stdout, NULL, _IONBF, 0); // ꂪKviWo͂̃obt@O𖳌ɂj

	InitializeCriticalSection(&cs); // NeBJZNVIuWFNg̏B
	bool isSuccess = BeginThread(); // MXbhJnB
	if (!isSuccess) {
		printf("Failed to begin thread\n");
		return -1;
	}

	init_shogi();


	while (true) {
		while (true) {
			// ΋Ǒ҂̃[vBsetoptionR}hĂ炻̒lݒ肷B
			// usinewgameR}hĂ炱̃[v𔲂đ΋ǂ̃[vɓB

			string commandStr = WaitCommand(); // MR}h擾
			const char *buf = commandStr.c_str();
			int len = strlen(buf);
			if (strncmp(buf, "usi", len) == 0) {
				// GWNAԍŏɌĂ΂R}hBɑ΂ăGWidԂƁA
				// GWŐݒ\ȃp[^optionR}hŕԂAŌusiokԂKvB
				printf("id name simk_1231\n");
				printf("id author simk_1231\n");
				printf("usiok\n");
			} else if (strncmp(buf, "isready", len) == 0) {
				// {̓ƊmۂłǂׂĂreadyokԂׂ
				// ʓ|Ȃ̂ŉׂreadyokԂĂB
				printf("readyok\n");
			} else if (strncmp(buf, "setoption", strlen("setoption")) == 0) {
				// GWɐݒ肷p[^Ă̂łݒ肵A
				// GWŗL̃p[^łΏݒt@CɕۑB
			} else if (strncmp(buf, "usinewgame", len) == 0) {
				// VK΋ǊJñR}hBM炱̃[v𔲂B
				break;
			}
		}
		//*****************************************************
		//					GW
		//*****************************************************

		init_shogi();


		while (true) {
			// ΋ǂ̃[vB΋ǎ̃R}ĥ͂̒ōsB
			// gameoverR}hĂ炱̃[v𔲂đ΋Ǒ҂̃[vɖ߂B

			string commandStr = WaitCommand(); // MR}h擾B
			const char *buf = commandStr.c_str();


			int len = strlen(buf);
			if (strncmp(buf, "position", strlen("position")) == 0) {

				// ݋ǖʂw肷R}hB
				if (strncmp(buf, "position startpos", strlen("position startpos")) == 0) {
					// Jnǖʌ̎w̏񂪂ꍇAǖʂi߂B
					make_moves_from_usi(buf, strlen(buf));

				} else {

					// SFENŎw肳ǖʂ̊Jn
					//if (commandStr.find(" moves ") != string::npos) {
					//}
				}
				continue;
			} else if (strncmp(buf, "go", strlen("go")) == 0 &&
					strncmp(buf, "go ponder", strlen("go ponder")) != 0 &&
					strncmp(buf, "go mate", strlen("go mate")) != 0) {
					//*****************************************************
					//					GWvl
					//*****************************************************	
					printf("bestmove %s", think_usi() );
					printf("\n");
					
				continue;
			} else if (strncmp(buf, "go ponder", strlen("go ponder")) == 0) {
				//*****************************************************
				//					GWponder
				//*****************************************************					
				// \zǖʂ̎vlJnBǂ݂Ȃ̂ŁA̒ŎԂĂ͂ȂB

				continue;
			} else if (strncmp(buf, "go mate", strlen("go mate")) == 0) {
				// l̎vlJnB
				continue;
			} else if (strncmp(buf, "stop", strlen("stop")) == 0) {
				// go܂go ponderŊɒTς݂̎ԂB
				// goɑ΂stopłΊɋǖʂi߂Ă邵A
				// go ponderɑ΂stopł΋ǖʂi߂Kv͂Ȃiposition
				// Ă܂ĵŁAǖʂɊւĂ͉ύXȂĂ悢B

				continue;
			} else if (strncmp(buf, "ponderhit", strlen("ponderhit")) == 0) {
				// ɓ̂bestmove ... ponder ...ŕԂ\z肪B
				// \z܂ł̋ǖʂ͐ił邪AwɊւĂ͂ŋǖʂi߂KvB

				// ponderhitMO0ɖ߂ĂBbestmoveԂƁA̒ponderhit
				// Ă邱ƂAɂĂ܂ponderhitReceiveTimeݒ肷̂ŁA
				// 0ɂĂ܂Ȃ悤AbestmoveԂO0ɖ߂Ȃ΂ȂB
				// ɒTς݂̎ԂB

				continue;
			} else if (strncmp(buf, "gameover", strlen("gameover")) == 0) {
				// gameoverƂR}hUSǏĂɂ͂ȂA΋ǏIGW
				// m点邽߂ɓƎɒǉBM炱̃[v𔲂
				// ΋Ǒ҂̃[vɖ߂B
				// gameover [ win | lose | draw ]Ƃ悤ɁAgameover̂ƂɌʒʒm
				// p[^̂ŁAwK̂ł΂gB
				break;
			}
		}
	}

	return 0;
}
